/*
 * @file Client_Module_Im.c
 * Module Interface for Module Client_Module_Im
 */
#include <stdio.h>

#include "Client_Module_Im.h"
#include <stdio.h>

void Client_Module_Im__INITIALIZE__received(Client_Module_Im__context *context)
{
   context->user.state = simple_lifecycle__state_IDLE;
}

void Client_Module_Im__START__received(Client_Module_Im__context *context)
{
   /* User Code Here */
}

void Client_Module_Im__STOP__received(Client_Module_Im__context *context)
{
   /* User Code Here */
}

void Client_Module_Im__SHUTDOWN__received(Client_Module_Im__context *context)
{
   /* User Code Here */
}

void Client_Module_Im__tick__received(Client_Module_Im__context *context)
{
   ECOA__log log;

   if (context->user.state == simple_lifecycle__state_RUNNING)
   {
      ECOA__global_time time;
      ECOA__return_status return_status;
      example__value_type val;

      return_status = Client_Module_Im_container__get_absolute_system_time(context, &time);

      val = 0;

      log.current_size = sprintf((char *) &log.data, "val before request = %d", val);
      Client_Module_Im_container__log_info(context, log);

      return_status = Client_Module_Im_container__Request_Val__request_sync(context, &time, &val);

      log.current_size = sprintf((char *) &log.data, "val from response = %d", val);
      Client_Module_Im_container__log_info(context, log);
   }
   else
   {
      log.current_size = sprintf((char *) &log.data, "client received tick - not doing any functional work as IDLE");
      Client_Module_Im_container__log_info(context, log);
   }
}

void Client_Module_Im__start__request_received
   (Client_Module_Im__context* context,
    const ECOA__uint32 ID)
{
   ECOA__return_status status;

   context->user.state = simple_lifecycle__state_RUNNING;

   status = Client_Module_Im_container__start__response_send(context, ID, context->user.state);
}

void Client_Module_Im__stop__request_received
   (Client_Module_Im__context* context,
    const ECOA__uint32 ID)
{
   ECOA__return_status status;

   context->user.state = simple_lifecycle__state_IDLE;

   status = Client_Module_Im_container__stop__response_send(context, ID, context->user.state);
}

void Client_Module_Im__get_current_state__request_received
   (Client_Module_Im__context* context,
    const ECOA__uint32 ID)
{
   ECOA__return_status status;

   status = Client_Module_Im_container__get_current_state__response_send(context, ID, context->user.state);
}
