/*
 * @file Manager_Module_Im.c
 * Module Interface for Module Manager_Module_Im
 */

#include "Manager_Module_Im.h"
#include <stdio.h>

void Manager_Module_Im__INITIALIZE__received(Manager_Module_Im__context *context)
{
   context->user.count = 0;
}

void Manager_Module_Im__START__received(Manager_Module_Im__context *context)
{
   /* User Code Here */
}

void Manager_Module_Im__STOP__received(Manager_Module_Im__context *context)
{
   /* User Code Here */
}

void Manager_Module_Im__SHUTDOWN__received(Manager_Module_Im__context *context)
{
   /* User Code Here */
}

void Manager_Module_Im__tick__received(Manager_Module_Im__context *context)
{
   ECOA__return_status status;
   simple_lifecycle__state serverState;
   simple_lifecycle__state clientState;
   ECOA__log log;

   if (context->user.count == 1)
   {
      // Start both server and client.
      log.current_size = sprintf((char *) &log.data, "manager requesting client and server components to start");
      Manager_Module_Im_container__log_info(context, log);

      status = Manager_Module_Im_container__start_server__request_sync(context, &serverState);
      status = Manager_Module_Im_container__start_client__request_sync(context, &serverState);
   }
   else if (context->user.count == 2)
   {
      // Stop the server.
      log.current_size = sprintf((char *) &log.data, "manager requesting server component to stop");
      Manager_Module_Im_container__log_info(context, log);

      status = Manager_Module_Im_container__stop_server__request_sync(context, &serverState);
   }
   else if (context->user.count == 3)
   {
      // Stop the client.
      log.current_size = sprintf((char *) &log.data, "manager requesting client component to stop");
      Manager_Module_Im_container__log_info(context, log);

      status = Manager_Module_Im_container__stop_client__request_sync(context, &serverState);
   }
   else
   {
      context->user.count = 0;
   }

   context->user.count++;
}

