/*
 * @file Server_Module_Im.c
 * Module Interface for Module Server_Module_Im
 */

#include "Server_Module_Im.h"
#include <stdio.h>

void Server_Module_Im__INITIALIZE__received(Server_Module_Im__context *context)
{
   context->user.state = simple_lifecycle__state_IDLE;
}

void Server_Module_Im__START__received(Server_Module_Im__context *context)
{
   /* User Code Here */
}

void Server_Module_Im__STOP__received(Server_Module_Im__context *context)
{
   /* User Code Here */
}

void Server_Module_Im__SHUTDOWN__received(Server_Module_Im__context *context)
{
   /* User Code Here */
}

void Server_Module_Im__Request_for_Val__request_received(Server_Module_Im__context* context, const ECOA__uint32 ID, const ECOA__global_time* time)
{
   if (context->user.state == simple_lifecycle__state_RUNNING)
   {
      ECOA__return_status return_status;
      return_status = Server_Module_Im_container__Request_for_Val__response_send(context, ID, 10);
   }
   else
   {
      ECOA__log log;
      log.current_size = sprintf((char *) &log.data, "server received Request_for_Val when IDLE - ignoring request!");
      Server_Module_Im_container__log_info(context, log);
   }
}

void Server_Module_Im__start__request_received
   (Server_Module_Im__context* context,
    const ECOA__uint32 ID)
{
   ECOA__return_status status;

   context->user.state = simple_lifecycle__state_RUNNING;

   status = Server_Module_Im_container__start__response_send(context, ID, context->user.state);
}

void Server_Module_Im__stop__request_received
   (Server_Module_Im__context* context,
    const ECOA__uint32 ID)
{
   ECOA__return_status status;

   context->user.state = simple_lifecycle__state_IDLE;

   status = Server_Module_Im_container__stop__response_send(context, ID, context->user.state);
}

void Server_Module_Im__get_current_state__request_received
   (Server_Module_Im__context* context,
    const ECOA__uint32 ID)
{
   ECOA__return_status status;

   status = Server_Module_Im_container__get_current_state__response_send(context, ID, context->user.state);
}
